import { CustomTransform, FilledAutolinkOptions, BuildInTransforms, AutolinkOptions, AutolinkTransforms } from './interfaces';
declare const compiledSettingMarker: unique symbol;
/**
 * Precompilation of autolink settings.
 */
export interface CompiledAutolinkSettings {
    [compiledSettingMarker]: true;
    options: FilledAutolinkOptions;
    transforms: CompiledTransform[];
}
export interface CompiledTransform {
    pattern: RegExp;
    transform: (options: FilledAutolinkOptions, ...args: string[]) => any;
}
/**
 * Compiled options.
 */
export declare function compile(transforms: AutolinkTransforms | undefined, options: AutolinkOptions | undefined): CompiledAutolinkSettings;
/**
 * Compile given setting.
 */
export declare function compileTransform(transform: BuildInTransforms | CustomTransform, options: FilledAutolinkOptions): CompiledTransform;
/**
 * Check whether given object is a compiled options.
 */
export declare function isCompiledOptions(options: unknown): options is CompiledAutolinkSettings;
export {};
