/**
 * Name of builtin transforms.
 */
export declare type BuildInTransforms = 'url';
export declare type AutolinkTransforms = Array<BuildInTransforms | CustomTransform>;
export interface CustomTransform {
    pattern(options: FilledAutolinkOptions): RegExp;
    transform(options: FilledAutolinkOptions, ...args: Array<string>): any;
}
export interface FilledAutolinkOptions {
    url: {
        requireSchemes: boolean;
        schemes: Array<string> | string;
        attributes: any;
        text?: (url: string) => string;
    };
}
export declare type AutolinkOptions = DeepOptional<FilledAutolinkOptions>;
/**
 * Deeply optionalize all properties.
 */
export declare type DeepOptional<T> = T extends any[] ? T : T extends Function ? T : T extends object ? {
    [K in keyof T]-?: DeepOptionalObject<T[K]>;
} : T;
declare type DeepOptionalObject<T> = {
    [P in keyof T]?: DeepOptional<T[P]>;
};
export {};
